/// <summary>
/// gets the list of databases
/// </summary>
/// <author> Rajesh Pillai</author>
/// <Date> March 2004 </Date>

using System;
using System.Data.SqlClient;
using System.Data;
using DataLayer;

namespace QASharp
{
	public class DataBase
	{
		public DataTable GetDatabases()
		{
			DataTable dt = null;
			string [] arrConn;									
			string uid = "";
			string pwd = "";
			string server = "";
			string database= "";


			if (dt == null)
			{

				arrConn = System.Configuration.ConfigurationSettings.AppSettings.GetValues("uid");
				uid = arrConn[0];
				arrConn = System.Configuration.ConfigurationSettings.AppSettings.GetValues("pwd");
				pwd = arrConn[0];
				arrConn = System.Configuration.ConfigurationSettings.AppSettings.GetValues("server");
				server = arrConn[0];
				arrConn = System.Configuration.ConfigurationSettings.AppSettings.GetValues("database");
				database= arrConn[0];
				
				SqlDBHandler db = new SqlDBHandler(server,"master",uid,pwd);

				try
				{
					dt = db.ExecDT ("sp_helpdb");
				}
				catch (Exception ex)
				{
					Console.WriteLine(ex.Message);
					throw ex;
				}
			
			}

			return dt;
		}

		/// <summary>
		/// Gets the list of databases
		/// </summary>
		/// <param name="server"></param>
		/// <param name="uid"></param>
		/// <param name="pwd"></param>
		/// <param name="database"></param>
		/// <returns></returns>
		public DataTable GetDatabases(string server, string uid, string pwd, string database)
		{
			DataTable dt = null;
			
			if (dt == null)
			{
				SqlDBHandler db = new SqlDBHandler(server,database,uid,pwd);

				try
				{
					dt = db.ExecDT ("sp_helpdb");
				}
				catch (Exception ex)
				{
					throw ex;
				}
			
			}

			return dt;
		}

		/// <summary>
		/// 06-Oct-2004
		/// </summary>
		/// <param name="server"></param>
		/// <param name="database"></param>
		/// <returns></returns>
		public DataTable GetDatabases(string server, string database)
		{
			DataTable dt = null;
			
			///new SqlConnection("Data Source=localhost; Integrated Security=SSPI;" +
			///	"Initial Catalog=northwind");
			
			string conStr = "Data Source = " + server + ";Integrated Security=SSPI;Initial Catalog=" + database ;
			
			SqlDBHandler db = new SqlDBHandler(conStr);
			
			try
			{
				dt = db.ExecDT ("sp_helpdb");
			}
			catch (Exception ex)
			{
				throw ex;
			}
			return dt;
		}
	}
}
